﻿Imports System.Threading
Imports System.IO
Imports System.Net
Imports System.Text
Imports System.Windows.Forms


Public Class Form1

    Public HBServer As HBCONTROLMODLib.HBControl
    Private Cline() As String
    Private szRSP As String
    Private URL As String
    Private Back As String
    Private Forward As String
    Private Reload As String
    Private x As Integer
    Private y As Integer
    Private OnTop As String
    Private Transparency As Double
    Private TimerInterval As Integer
    Private ResolutionX As Integer
    Private ResolutionY As Integer
    Private ScrollBars As String
    Private ScrollRight As String
    Private ScrollLeft As String
    Private ScrollUp As String
    Private ScrollDown As String
    Private OldURL As String
    Private PageCounter As String
    Private OldBack As String
    Private OldForward As String
    Private OldReload As String
    Private OldX As Integer
    Private OldY As Integer
    Private OldTimerInterval As Integer
    Private OldResolutionX As Integer
    Private OldResolutionY As Integer
    Private OldTransparency As Integer
    Private OldOnTop As String
    Private OldScrollBars As String
    Private BrowserStop As String
    Private PortNumber As Integer
    Private IPAddress As String
    Private Password As String
    Private BrowserDevice As String
    Private InstanceType As String
    Private Window As Long
    Private ScrollXDistance As Integer
    Private ScrollYDistance As Integer
    Private ScrollXPosition As Integer
    Private ScrollYPosition As Integer
    Private mutexFile As Mutex
    Private Browser1 As New ExtendedWebBrowser

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler Browser1.NavigatingExtended, AddressOf Browser1_NavigatingExtended
        AddHandler Browser1.DocumentCompleted, AddressOf Browser1_DocumentCompleted
        AddHandler Browser1.NewWindowExtended, AddressOf Browser1_NewWindowExtended
        Me.Controls.Add(Browser1)
        Browser1.Dock = DockStyle.Fill
        Cline = Split(Command, "/")
        Dim i
        For i = 0 To UBound(Cline)
            Select Case Mid(Cline(i), 1, 1)
                Case "I" : IPAddress = Trim(Mid(Cline(i), 2, Len(Cline(i))))
                Case "O" : PortNumber = Trim(Mid(Cline(i), 2, Len(Cline(i))))
                Case "S" : Password = Trim(Mid(Cline(i), 2, Len(Cline(i))))
                Case "D" : BrowserDevice = Trim(Mid(Cline(i), 2, Len(Cline(i))))
                Case "C" : InstanceType = Trim(Mid(Cline(i), 2, Len(Cline(i))))
            End Select
        Next
        If Password = "*" Then
            Password = ""
        End If
        mutexFile = New Mutex(False, "HouseBot Browser")
        If InStr(InstanceType, "SIB") > 0 Then
            If mutexFile.WaitOne(0, False) = False Then
                mutexFile.Close()
                mutexFile = Nothing
                Me.Close()
                End
            End If
        End If
        Me.AutoScroll = True
        OldY = 10000
        OldX = 10000
        OldResolutionX = 10000
        OldResolutionY = 10000
        HBServer = New HBCONTROLMODLib.HBControl
        szRSP = HBServer.Connect(PortNumber, IPAddress, Password)
        If szRSP = "OK" Then
            Call GetHouseBotValues()
            Call SetBrowserParameters()
            Browser1.Navigate(URL)
            OldURL = URL
            ScrollXPosition = 0
            ScrollYPosition = 0
            Me.WindowState = 0
            Call HBServer.SetPropertyValue(BrowserDevice, "Execute Program", "No")
            Call HBServer.SetPropertyValue(BrowserDevice, "BrowserQuit", "False")
            Me.Timer1.Enabled = True
        Else
            MsgBox("Unable to connect to HouseBot. Please ensure HouseBot is open and External Control is configured.")
            Me.Close()
        End If
    End Sub

    Private Sub GetHouseBotValues()
        URL = CStr(HBServer.GetPropertyValue(BrowserDevice, "URL"))
        Back = CStr(HBServer.GetPropertyValue(BrowserDevice, "Back"))
        Forward = CStr(HBServer.GetPropertyValue(BrowserDevice, "Forward"))
        Reload = CStr(HBServer.GetPropertyValue(BrowserDevice, "Reload"))
        x = HBServer.GetPropertyValue(BrowserDevice, "X")
        If IsNumeric(x) Then
            x = CInt(x)
        Else
            x = 0
            HBServer.SetPropertyValue(BrowserDevice, "X", x)
        End If
        y = HBServer.GetPropertyValue(BrowserDevice, "Y")
        If IsNumeric(y) Then
            y = CInt(y)
        Else
            y = 0
            HBServer.SetPropertyValue(BrowserDevice, "Y", y)
        End If
        TimerInterval = HBServer.GetPropertyValue(BrowserDevice, "TimerInterval")
        If IsNumeric(TimerInterval) Then
            TimerInterval = CInt(TimerInterval)
        Else
            TimerInterval = 500
            HBServer.SetPropertyValue(BrowserDevice, "TimerInterval", TimerInterval)
        End If
        If TimerInterval < 100 Then TimerInterval = 100
        ResolutionX = HBServer.GetPropertyValue(BrowserDevice, "ResolutionX")
        If IsNumeric(ResolutionX) Then
            ResolutionX = CInt(ResolutionX)
        Else
            ResolutionX = 400
            HBServer.SetPropertyValue(BrowserDevice, "ResolutionX", ResolutionX)
        End If
        ResolutionY = HBServer.GetPropertyValue(BrowserDevice, "ResolutionY")
        If IsNumeric(ResolutionY) Then
            ResolutionY = CInt(ResolutionY)
        Else
            ResolutionY = 800
            HBServer.SetPropertyValue(BrowserDevice, "ResolutionY", ResolutionY)
        End If
        Transparency = HBServer.GetPropertyValue(BrowserDevice, "Transparency")
        If IsNumeric(Transparency) Then
            Transparency = CDbl(Transparency)
        Else
            Transparency = 1
            Transparency = CDbl(Transparency)
            HBServer.SetPropertyValue(BrowserDevice, "Transparency", Transparency)
        End If
        If Transparency > 1 Then
            Transparency = 1
            HBServer.SetPropertyValue(BrowserDevice, "Transparency", Transparency)
        End If
        If Transparency < 0 Then
            Transparency = 0
            HBServer.SetPropertyValue(BrowserDevice, "Transparency", Transparency)
        End If
        OnTop = CStr(HBServer.GetPropertyValue(BrowserDevice, "OnTop"))
        ScrollBars = CStr(HBServer.GetPropertyValue(BrowserDevice, "ScrollBars"))
        BrowserStop = CStr(HBServer.GetPropertyValue(BrowserDevice, "BrowserQuit"))
        ScrollRight = CStr(HBServer.GetPropertyValue(BrowserDevice, "ScrollRight"))
        ScrollLeft = CStr(HBServer.GetPropertyValue(BrowserDevice, "ScrollLeft"))
        ScrollUp = CStr(HBServer.GetPropertyValue(BrowserDevice, "ScrollUp"))
        ScrollDown = CStr(HBServer.GetPropertyValue(BrowserDevice, "ScrollDown"))
        ScrollXDistance = HBServer.GetPropertyValue(BrowserDevice, "ScrollXDistance")
        If IsNumeric(ScrollXDistance) Then
            ScrollXDistance = CInt(ScrollXDistance)
        Else
            ScrollXDistance = 100
            HBServer.SetPropertyValue(BrowserDevice, "ScrollXDistance", ScrollXDistance)
        End If
        ScrollYDistance = CInt(HBServer.GetPropertyValue(BrowserDevice, "ScrollYDistance"))
        If IsNumeric(ScrollYDistance) Then
            ScrollYDistance = CInt(ScrollYDistance)
        Else
            ScrollYDistance = 100
            HBServer.SetPropertyValue(BrowserDevice, "ScrollYDistance", ScrollYDistance)
        End If
    End Sub

    Private Sub SetBrowserParameters()
        If TimerInterval <> OldTimerInterval Then
            Me.Timer1.Interval = TimerInterval
            OldTimerInterval = TimerInterval
        End If
        If ScrollBars <> OldScrollBars Then
            If ScrollBars = "True" Then
                Browser1.ScrollBarsEnabled = True
            Else
                Browser1.ScrollBarsEnabled = False
            End If
            OldScrollBars = ScrollBars
        End If
        If Transparency <> OldTransparency Then
            Me.Opacity = Transparency
            OldTransparency = Transparency
            HBServer.SetPropertyValue(BrowserDevice, "Transparency", Transparency)
        End If
        If OnTop <> OldOnTop Then
            If OnTop = "True" Then
                Me.TopMost = True
            Else
                Me.TopMost = False
            End If
            OldOnTop = OnTop
        End If
        If y <> OldY Then
            Me.Top = y
            OldY = y
        End If
        If x <> OldX Then
            Me.Left = x
            OldX = x
        End If
        If ResolutionX <> OldResolutionX Then
            Me.Width = ResolutionX
            Browser1.Width = Me.Width
            OldResolutionX = ResolutionX
        End If
        If ResolutionY <> OldResolutionY Then
            Me.Height = ResolutionY
            Browser1.Height = Me.Height
            OldResolutionY = ResolutionY
        End If
        If URL <> OldURL Then
            Browser1.Navigate(URL)
            OldURL = URL
            ScrollXPosition = 0
            ScrollYPosition = 0
        End If
        If Browser1.ReadyState <> WebBrowserReadyState.Complete Then Exit Sub
        If Back = "True" Then
            Browser1.GoBack()
            Back = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "Back", "False")
        ElseIf Back <> "True" And Back <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "Back", "False")
            Back = "False"
        End If
        If Forward = "True" Then
            Browser1.GoForward()
            Forward = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "Forward", "False")
        ElseIf Forward <> "True" And Forward <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "Forward", "False")
            Forward = "False"
        End If
        If Reload = "True" Then
            Browser1.Refresh()
            Reload = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "Reload", "False")
        ElseIf Reload <> "True" And Reload <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "Reload", "False")
            Reload = "False"
        End If
        If BrowserStop = "True" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "BrowserQuit", "False")
            Me.Close()
            Exit Sub
        ElseIf BrowserStop <> "True" And BrowserStop <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "BrowserQuit", "False")
        End If
        If ScrollRight = "True" Then
            ScrollXPosition = ScrollXPosition + ScrollXDistance
            If ScrollXPosition > CInt(Browser1.Document.Body.ScrollRectangle.Width) Then
                ScrollXPosition = CInt(Browser1.Document.Body.ScrollRectangle.Width)
            End If
            Browser1.Document.Window.ScrollTo(ScrollXPosition, ScrollYPosition)
            ScrollRight = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollRight", "False")
        ElseIf ScrollRight <> "True" And ScrollRight <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollRight", "False")
            ScrollRight = "False"
        End If
        If ScrollLeft = "True" Then
            ScrollXPosition = ScrollXPosition - ScrollXDistance
            If ScrollXPosition < 0 Then ScrollXPosition = 0
            Browser1.Document.Window.ScrollTo(ScrollXPosition, ScrollYPosition)
            ScrollLeft = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollLeft", "False")
        ElseIf ScrollLeft <> "True" And ScrollLeft <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollLeft", "False")
            ScrollLeft = "False"
        End If
        If ScrollUp = "True" Then
            ScrollYPosition = ScrollYPosition - ScrollYDistance
            If ScrollYPosition < 0 Then ScrollYPosition = 0
            Browser1.Document.Window.ScrollTo(ScrollXPosition, ScrollYPosition)
            ScrollUp = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollUp", "False")
        ElseIf ScrollUp <> "True" And ScrollUp <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollUp", "False")
            ScrollUp = "False"
        End If
        If ScrollDown = "True" Then
            ScrollYPosition = ScrollYPosition + ScrollYDistance
            If ScrollYPosition > CInt(Browser1.Document.Body.ScrollRectangle.Height) Then
                ScrollYPosition = CInt(Browser1.Document.Body.ScrollRectangle.Height)
            End If
            Browser1.Document.Window.ScrollTo(ScrollXPosition, ScrollYPosition)
            ScrollDown = "False"
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollDown", "False")
        ElseIf ScrollDown <> "True" And ScrollDown <> "False" Then
            Call HBServer.SetPropertyValue(BrowserDevice, "ScrollDown", "False")
            ScrollDown = "False"
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If OnTop = "True" Then
            Me.TopMost = True
        End If
        If Me.WindowState <> FormWindowState.Normal Then
            Me.WindowState = FormWindowState.Normal
        End If
        If Browser1.ReadyState <> WebBrowserReadyState.Complete Then
            Exit Sub
        End If
        Call GetHouseBotValues()
        Call SetBrowserParameters()
    End Sub

    Private Sub Browser1_NavigatingExtended(ByVal sender As Object, ByVal e As ExtWebBrowser.WebBrowserNavigatingExtendedEventArgs)

        'This is a new event

        'Dim postdata As String = e.Postdata
        'Dim msg As String = "Navigating to : " & e.Url & ControlChars.CrLf
        'msg &= "Postdata : " & postdata & ControlChars.CrLf
        'msg &= "Headers : " & e.Headers & ControlChars.CrLf
        'msg &= "Frame : " & e.Frame & ControlChars.CrLf
        'msg &= "Continue ?"
        'Dim res As DialogResult = MessageBox.Show(msg, "NavigatingExtended", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        'If res = Windows.Forms.DialogResult.No Then e.Cancel = True

    End Sub

    Private Sub Browser1_DocumentCompleted(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs)
        'This is a standard event

        'MessageBox.Show("Document complete: " & e.Url.ToString, "DocumentCompleted", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

    Private Sub Browser1_NewWindowExtended(ByVal sender As Object, ByVal e As ExtWebBrowser.WebBrowserNewWindowExtendedEventArgs)
        'This is a new event

        'Dim msg As String = "Navigation vers : " & e.Url & ControlChars.CrLf
        'msg &= "UrlContext : " & e.UrlContext & ControlChars.CrLf
        'msg &= "Flags : " & e.Flags.ToString & ControlChars.CrLf
        'msg &= "Continue ?"
        'Dim res As DialogResult = MessageBox.Show(msg, "NewWindowExtended", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        'If res = Windows.Forms.DialogResult.No Then e.Cancel = True
        e.Cancel = True
    End Sub

End Class
